Subject: Re: bug#14968: Building guix on top of Ubuntu 13.04

From: Nikita Karetnikov <[email-masked]>
Date: Mon, 29 Jul 2013 08:44:36 +0400

> I tried to install guix on top of Ubuntu, downloaded guix 0.3 and
> installed the required dependecies.

What version of Guile did you use?

> I tried to first run guix pull but failed with an error on /nix/store
> with wrong rights, the error provided a command to run which I did.
> After that I run again guix pull and try to install zile with the
> command guix package -i zile

Could you specify all commands that you used (after you had fetched the
tarball)?  So I could try to reproduce the problem.

> It fails with the following error:

> http://paste.call-cc.org/paste?id=6fdc9664ba6f81cfc0e32d168502945e1d6c95f9

Please attach logs in the future.  We shouldn't rely on third party
services.

Backtrace:
In guix/packages.scm:
 309: 19 [cache # "x86_64-linux" #<procedure thunk ()>]
 384: 18 [thunk]
In srfi/srfi-1.scm:
 578: 17 [map #<procedure 2701b40 at guix/packages.scm:385:39 (t-215469)> #]
In guix/packages.scm:
 346: 16 [expand-input # # # ...]
 309: 15 [cache # "x86_64-linux" #<procedure thunk ()>]
 384: 14 [thunk]
In srfi/srfi-1.scm:
 578: 13 [map #<procedure 274c000 at guix/packages.scm:385:39 (t-215469)> #]
In guix/packages.scm:
 346: 12 [expand-input # # # ...]
 309: 11 [cache # "x86_64-linux" #<procedure thunk ()>]
 384: 10 [thunk]
In srfi/srfi-1.scm:
 578: 9 [map #<procedure 2762690 at guix/packages.scm:385:39 (t-215469)> #]
In guix/packages.scm:
 361: 8 [expand-input # # # ...]
In guix/download.scm:
 189: 7 [url-fetch # "mirror://gnu/gmp/gmp-5.1.2.tar.xz" sha256 ...]
In guix/packages.scm:
 309: 6 [cache # "x86_64-linux" #<procedure thunk ()>]
 396: 5 [thunk]
In gnu/packages/bootstrap.scm:
 169: 4 [build # "guile-bootstrap-2.0" #f ...]
In guix/store.scm:
 478: 3 [#<procedure 2228440 at guix/store.scm:468:4 (server basename recursive? hash-algo file-name)> # ...]
 461: 2 [add-to-store # "tar" #t ...]
In guix/nar.scm:
 148: 1 [dump "/home/amirouche/.config/guix/latest/gnu/packages/bootstrap/x86_64-linux/tar"]
  79: 0 [write-contents "/home/amirouche/.config/guix/latest/gnu/packages/bootstrap/x86_64-linux/tar" ...]

guix/nar.scm:79:8: In procedure write-contents:
guix/nar.scm:79:8: In procedure module-lookup: Unbound variable: sendfile

> I can't install guile 2.0.9 on ubuntu because of some file clash
> regarding ffi.

Please send a message to [email-masked] if you can't find anything
here [1].

> Instead I looked in /nix/store and saw that guile 2.0.9 was installed by guix

> so I symlinked it in ~/.guix-profile/bin/

> replaced the shebang of /usr/local/bin/guix with  /usr/bin/env guile

I think that the above might cause some problems.  Normally, you don't
have to touch the store (i.e., '/nix/store') at all.  Could you specify
the absolute location of that Guile 2.0.9 directory?

> Running guix package -i zile still fails with the following error:

> http://paste.call-cc.org/paste?id=0372e8cc7d7e2849d1b57a2926e0b359b072fa05

;;; note: source file /usr/local/bin/guix
;;;       newer than compiled /home/amirouche/.cache/guile/ccache/2.0-LE-8-2.0/usr/local/bin/guix.go
;;; note: auto-compilation is enabled, set GUILE_AUTO_COMPILE=0
;;;       or pass the --no-auto-compile argument to disable.
;;; compiling /usr/local/bin/guix
;;; compiled /home/amirouche/.cache/guile/ccache/2.0-LE-8-2.0/usr/local/bin/guix.go
Backtrace:
In guix/packages.scm:
  19: 19 [#<procedure 1125940 ()>]
In ice-9/boot-9.scm:
2870: 18 [define-module* (guix packages) #:filename ...]
2845: 17 [resolve-imports (((guix utils)) ((guix records)) ((guix store)) ...)]
2783: 16 [resolve-interface (guix derivations) #:select ...]
2708: 15 [#<procedure 99f2e0 at ice-9/boot-9.scm:2696:4 (name #:optional autoload version #:key ensure)> # ...]
2981: 14 [try-module-autoload (guix derivations) #f]
2320: 13 [save-module-excursion #<procedure 11365d0 at ice-9/boot-9.scm:2982:17 ()>]
3001: 12 [#<procedure 11365d0 at ice-9/boot-9.scm:2982:17 ()>]
In unknown file:
   ?: 11 [primitive-load-path "guix/derivations" ...]
In guix/derivations.scm:
  19: 10 [#<procedure 11815a0 ()>]
In ice-9/boot-9.scm:
2870: 9 [define-module* (guix derivations) #:filename ...]
2845: 8 [resolve-imports (((srfi srfi-1)) ((srfi srfi-9)) ((srfi srfi-26)) ...)]
2783: 7 [resolve-interface (guix hash) #:select ...]
2708: 6 [#<procedure 99f2e0 at ice-9/boot-9.scm:2696:4 (name #:optional autoload version #:key ensure)> # ...]
2981: 5 [try-module-autoload (guix hash) #f]
2320: 4 [save-module-excursion #<procedure 1186b70 at ice-9/boot-9.scm:2982:17 ()>]
3001: 3 [#<procedure 1186b70 at ice-9/boot-9.scm:2982:17 ()>]
In unknown file:
   ?: 2 [primitive-load-path "guix/hash" ...]
In guix/hash.scm:
  48: 1 [#<procedure 1187620 ()>]
In unknown file:
   ?: 0 [dynamic-link "libgcrypt"]

ERROR: In procedure dynamic-link:
ERROR: In procedure dynamic-link: file: "libgcrypt", message: "file not found"

Could you also try to install Guix from Git [2] and report any problems?

Finally, I hope that you'll switch to a free distro [3] instead of
Ubuntu that contains non-free [4] packages.

[1] https://lists.gnu.org/archive/html/bug-guile/
[2] http://git.savannah.gnu.org/cgit/guix.git/tree/HACKING#n13
[3] https://www.gnu.org/distros/free-distros.html
[4] https://www.gnu.org/philosophy/free-sw